/************************************************************************

About.cpp

Copyright (C) 2007 Virus
Copyright (C) 2002 mooby

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

************************************************************************/


#include "defines.h"
#include "externs.h"
#include <string.h>

//  About.cpp
//  has the config, about, and test functions and related structs
//  lots of this code was taken from PEOPS.  THANK YOU!!!!

#define WEBSITE "https://sourceforge.net/projects/pcsx-df/"
#ifdef _DEBUG
# ifdef SUPER_DEBUG
#define LIBNAME "DFBinImage super debug"
# else
#define LIBNAME "DFBinImage debug"
# endif
#else
#define LIBNAME "DFBinImage"
#endif
static char libName[] = LIBNAME;
static const char *pluginAuthor[] = {"Mooby","Virus","Micket (micketeer@gmail.com)", NULL};

static FPSEAbout aboutMooby = {FPSE_CDROM, 
   BUILD, 
   REVISION, 
   FPSE_OK, 
   "mooby",
   LIBNAME,
   "moo"};

#include "Utils.hpp"

/** PSX emu interface **/

// lots of this code was swiped from PEOPS.  thank you =)
char * CALLBACK PSEgetLibName(void)
{
 return libName;
}

unsigned long CALLBACK PSEgetLibType(void)
{
 return	PSE_LT_CDR;
}

unsigned long CALLBACK PSEgetLibVersion(void)
{
 return PLUGIN_VERSION<<16|REVISION<<8|BUILD;
}

void CALLBACK CDRabout(void)
{
	gchar* version;
	version = g_strdup_printf("%d.%d.%d\n", PLUGIN_VERSION, REVISION, BUILD);
    GtkWidget *dialog = gtk_about_dialog_new ();
    gtk_about_dialog_set_name(   GTK_ABOUT_DIALOG (dialog), libName);
    gtk_about_dialog_set_version(GTK_ABOUT_DIALOG (dialog), version);
    gtk_about_dialog_set_authors(GTK_ABOUT_DIALOG (dialog), pluginAuthor);
    gtk_about_dialog_set_website(GTK_ABOUT_DIALOG (dialog), WEBSITE);
	g_free (version);
	gtk_dialog_run (GTK_DIALOG (dialog));
	gtk_widget_destroy (dialog);
}

long CALLBACK CDRtest(void)
{
   moobyMessage("Of course it'll work.");
   return 0;
}

/** FPSE interface **/

void CD_About(UINT32 *par)
{
   memcpy(par, &aboutMooby, sizeof(FPSEAbout));
}

/** PCSX2 interface **/

void CALLBACK CDVDabout()
{
   CDRabout();
}

s32  CALLBACK CDVDtest()
{
  return CDRtest();
}

u32   CALLBACK PS2EgetLibType(void)
{
   return PS2E_LT_CDVD;
}

u32   CALLBACK PS2EgetLibVersion(void)
{
   return PSEgetLibVersion();
}

char* CALLBACK PS2EgetLibName(void)
{
   return PSEgetLibName();  
}

