/************************************************************************

  CompressCDDA.hpp

  Copyright (C) 2008 Micket

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 ************************************************************************/

#ifndef RIPCDDADATA_HPP
#define RIPCDDADATA_HPP

#include "FileInterface.hpp"
#include "CDTime.hpp"
#include "TrackInfo.hpp"
#include "TrackParser.hpp"
#include "Utils.hpp"
#include "Preferences.hpp"

#include <gtk/gtk.h>
#include <glib-2.0/glib.h>
#include <glib-2.0/glib/gstdio.h>

using namespace std;
// Some positions to edit
#define WAV_DATASIZE 4
#define WAV_SAMPLES 40

class RipCDDAData
{
    public:
        RipCDDAData(string file, GtkProgressBar* prog);
        ~RipCDDAData() {}
        bool hasCDDAData() { return trackList.size() > 2;}
        bool doRip();
        bool clearCDDA(); // Removes the CDDA data from the image.

    private:
        bool saveSong(int track);

        FileInterface* theCD;
        vector<TrackInfo> trackList;
        string filename;

        // The progress bar
        GtkProgressBar* prog;
};

#endif
